/**
 **	File ......... ConnectThread.h
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _CONNECTTHREAD_H
#define _CONNECTTHREAD_H


using iotm::IOMessage;




class EventThread;
class Player;
class Map;


typedef std::map<long,Player *> players_t;
typedef std::map<long,Map *> maps_t;


class ConnectThread : public iotm::IOThread
{
public:
	ConnectThread();
	ConnectThread(char *host, int port = DEFAULT_PORT);
	~ConnectThread();
	void Run();

	unsigned long get_ip(char *);
	IOMessage *GetClass(IO_IDTYPE);

	// cache stuff
	Player *AddPlayer(long);
	Player *AddPlayer(long,const string &);
	Player *GetPlayer(long);
	//
	void SetSelf(long num,const string &);
	Player *GetSelf(void);
	//
	Map *AddMap(long x,long y,Event::Map * = NULL);
	Map *GetMap(long x,long y);
	// end of cache stuff

private:
	short m_connected;
	char m_host[256];
	int m_port;
	unsigned long m_ip;
	EventThread *m_pclEventThread;
#pragma warning("this is where we should cache map, players, overlays, etc")
	Player *m_self;
	players_t m_players;
	maps_t m_maps;
};

#endif // _CONNECTTHREAD_H
