/**
 **	File ......... DotCursor.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>
#include <SDL_prim.h>

#include "DotCursor.h"

using gui::Surface;
using gui::coord_t;
using gui::SurfaceHelper;



DotCursor::DotCursor(Surface *s,coord_t x,coord_t y,SurfaceHelper *sh)
:Surface(s,x,y,11,11,sh)
{
	SetBgColor(255,255,255,0);	// transparent
	SetFgColor(128,255,128);
}


DotCursor::~DotCursor()
{
}


void DotCursor::Draw()
{
	SDL_Rect r = GetClientRect();
	SDL_FillRect(m_screen, &r, GetBgColor());
	SDL_fillCircle(m_screen, 5, 5, 5, GetFgColor());
	SDL_fillCircle(m_screen, 5, 5, 3, GetBgColor());
}


