/**
 **	File ......... EventThread.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>
//#include <libiotm.h>

#include "defaults.h"
#include "events/Map.h"
#include "Map.h"
#include "ConnectThread.h"
#include "EventFactory.h"

#include "EventThread.h"


EventThread::EventThread() : Thread() 
,m_pclConnectThread(NULL)
{
	printf("Event thread constructor\n");
}


EventThread::~EventThread()
{
	DEB(printf("~EventThread()\n");)
}


void EventThread::SetConnectThread(ConnectThread *pclThread) 
{
	m_pclConnectThread = pclThread;
}


void EventThread::Run()
{
	while (IsRunning())
	{
		SDL_Delay(20); // 20 ms
		if (m_pclConnectThread)
		{
//			DEB(printf("m_pclConnectThread: %d bytes waiting\n",m_pclConnectThread -> get_iq());)
			m_ef.StateMachine( m_pclConnectThread );
		}
		if (m_pclConnectThread && !m_pclConnectThread -> IsRunning())
		{
			SetRunning(false);
		}
	}

	// All done.
	SetRunning(false);
}


iotm::IOMessage *EventThread::GetClass(IO_IDTYPE id)
{
	return m_ef.GetClass(id);
}
