/**
 **	File ......... Globals.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>
//#include <libcgi++.h>

#include "defaults.h"
#include "util/Parse.h"
#include "Globals.h"

using util::Parse;


string Globals::m_host = "alhem.net";
int    Globals::m_port = DEFAULT_PORT;
double Globals::m_zx = -0.852693;
double Globals::m_zy = 0.353394;
double Globals::m_scale = 0.000596;


Globals::Globals()
{
	read_globals();
}


Globals::~Globals()
{
	write_globals();
}


void Globals::read_globals()
{
	FILE *fil;
	char slask[200];
	char value[200];

	if ((fil = fopen("globals.dat","rt")) != NULL)
	{
		fgets(slask,200,fil);
		while (!feof(fil))
		{
			slask[strlen(slask) - 1] = 0;
			Parse pa(slask);
			pa.getword(slask);
			pa.getrest(value);
			if (!strcmp(slask,"host"))
			{
				m_host = value;
			}
			else
			if (!strcmp(slask,"port"))
			{
				m_port = atoi(value);
			}
			else
			if (!strcmp(slask,"zx"))
			{
				m_zx = atof(value);
			}
			else
			if (!strcmp(slask,"zy"))
			{
				m_zy = atof(value);
			}
			else
      if (!strcmp(slask,"scale"))
      {
        m_scale = atof(value);
      }
      else
			{
				fprintf(stderr,"Unknown key '%s'\n", slask);
			}
			fgets(slask,200,fil);
		}
		fclose(fil);
	}
}


void Globals::write_globals()
{
	FILE *fil;

	if ((fil = fopen("globals.dat","wt")) != NULL)
	{
		fprintf(fil,"host %s\n",m_host.c_str());
		fprintf(fil,"port %d\n",m_port);
    fprintf(fil,"zx %f\n",m_zx);
    fprintf(fil,"zy %f\n",m_zy);
    fprintf(fil,"scale %f\n",m_scale);
		fclose(fil);
	}
}

