/**
 **	File ......... Grid.h
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _GRID_H
#define _GRID_H

#include <events/Facing.h>
#include <events/Position.h>


class Grid
{
public:
	Grid();
	~Grid();

	void ReCalculate();

	void SetSize(int,int);
	void SetBase(int);
	void SetDirection(Event::Facing *);
	void SetPosition(Event::Position *);

	int GetBase();
	int GetWidth();
	int GetHeight();
	void GetXY(int x,int y,int *cx,int *cy,int *elevation);
	int GetHBase();
	double Sin(int);

private:
	int m_x;		// xmax
	int m_y;		// ymax
	int m_base;		// sida
	int m_hbase;
	int m_left;		// first x coordinates outside screen
	int m_right;
	int m_top;		// first y coordinates outside screen
	int m_bottom;
	int m_w;
	int m_h;
	double m_sin[360];
	int m_riktning;		// 0..5
	int m_xpos;		// 0..
	int m_ypos;		// 0..
};


#endif // _GRID_H
