/**
 **	File ......... InitSDL.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "client.h"
#include "InitSDL.h"


InitSDL::InitSDL(int argc,char *argv[]) : gui::SDLControl(argc,argv)
{
}


InitSDL::~InitSDL() 
{
}


/* Draw a randomly sized and colored box centered about (X,Y) */
void InitSDL::DrawBox(int X, int Y)
{
	static unsigned int seeded = 0;
	SDL_Rect area;
	Uint32 color;

	/* Seed the random number generator */
	if ( seeded == 0 ) 
	{
		srand(time(NULL));
		seeded = 1;
	}

	/* Get the bounds of the rectangle */
	area.w = (rand() % XMAX);
	area.h = (rand() % YMAX);
	area.x = X - (area.w / 2);
	area.y = Y - (area.h / 2);
	color = (rand() % NUM_COLORS);
	color = 0;

	/* Do it! */
	LockMutex();
	SDL_FillRect(GetScreen(), &area, color);
	SDL_UpdateRects(GetScreen(), 1, &area);
	UnlockMutex();
}


/*
void InitSDL::Init_SDL()
{
	DEB(printf("SDL_Init()\n");)
	if (SDL_Init( SDL_INIT_TIMER|SDL_INIT_VIDEO ) < 0)
	{
		DEB(printf("SDL_Init() ej ok\n");)
		fprintf(stderr,"SDL error: %s\n",SDL_GetError() );
	}
	else
	{
		DEB(printf("SDL_Init() OK\n");)
//		m_ok = true;
		SetOK(true);
	}
}
*/


