/**
 **	File ......... LoginDialog.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "client.h"
#include "Globals.h"
#include "FormSurface.h"
#include "forms/Login.h"
#include "MainWindow.h"
#include "LoginDialog.h"

using Form::Login;


LoginDialog::LoginDialog(Surface *s)
:FormSurface(s, 220, 140, 200, 200)
,m_st1 (this, 5, 5, 150, 25)
,m_login(this, 5, 35, 150, 25)
,m_st2 (this, 5, 65, 150, 25)
,m_passwd(this, 5, 95, 150, 25)
,m_ok (this, 5, 125, 90, 25)
,m_cancel(this,105,125, 90, 25)
{
	Uint32 bgcolor = SDL_MapRGBA(GetScreen() -> format, 192, 192, 192, 128);
	Uint32 txtcolor = SDL_MapRGBA(GetScreen() -> format, 255, 192, 64, 255);

	SetText("LoginDialog");
	CreateTemporaryScreen();
	
//	SetBgColor(bgcolor);
//	SetFgColor(txtcolor);
	SetMoveable(true);

	m_st1.SetText("Login");
	m_st2.SetText("Password");
	m_passwd.SetEcho('*');
	m_ok.SetText("OK");
	m_cancel.SetText("Cancel");
	
	UpdateData(false);
	
	AddChild(&m_st1);
	AddChild(&m_login);
	AddChild(&m_st2);
	AddChild(&m_passwd);
	AddChild(&m_ok);
	AddChild(&m_cancel);
}


LoginDialog::~LoginDialog()
{
}


void LoginDialog::OnEvent(surface_event_t *pstEvent)
{
	if (pstEvent -> type == GUI_EVENT_BUTTON)
	{
		Login *pclForm = dynamic_cast<Login *>(GetForm());
		if (pstEvent -> local_id == m_ok.GetLocalID())
		{
			UpdateData();
			if (pclForm)
			{
				pclForm -> SetFormDoneOK();
			}
			OnClose();
		}
		else
		if (pstEvent -> local_id == m_cancel.GetLocalID())
		{
			if (pclForm)
			{
				pclForm -> SetFormDoneCancel();
			}
			OnClose();
		}
	}
}


void LoginDialog::Draw()
{
	SDL_Rect *area = GetClientRectPtr();
	Uint32 color = GetBgColor();

	SDL_FillRect(m_screen, area, color);
}


void LoginDialog::UpdateData(bool dlg2vars)
{
	if (dlg2vars)
	{
		Login *pclForm = dynamic_cast<Login *>(GetForm());
		
		if (pclForm)
		{
			pclForm -> SetLogin(m_login.GetLine());
DEB(	printf("Login '%s'\n",m_login.GetLine());)
			pclForm -> SetPassword(m_passwd.GetLine());
DEB(	printf("Password '%s'\n",m_passwd.GetLine());)
		}
		else
		{
DEB(	printf("Not a Login Form???\n");)
		}
//		Globals::m_login = m_login.GetLine();
//		Globals::m_passwd = atoi(m_passwd.GetLine());
	}
	else
	{
		m_login.SetLine("");
		m_passwd.SetLine("");
	}
}

