/**
 **	File ......... Main.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "defaults.h"
#include "WinSockInit.h"
#include "InitSDL.h"
#include "DotCursor.h"
#include "MainWindow.h"
//#include "Surface.h"
#include "Globals.h"
#include "client.h"
#include "Main.h"



#undef DEB
#ifdef _DEBUG
#define DEB(x) x
#else
#define DEB(x)
#endif


Main::Main(int argc,char *argv[])
:GuiEvent()
,m_clControl(argc,argv,XMAX,YMAX) //m_clInitSDL(argc,argv)
,m_pclMainWindow(NULL)
,m_angle1(90)
,m_angle2(1)
{
	if (IsOK())
	{
		DEB(printf("Allt OK\n");)
		m_pclMainWindow = new MainWindow( &m_clControl );
	}
	else
	{
		DEB(printf("Ej OK\n");)
	}

	// init gui event
	if (IsOK())
	{
		SetRootSurface(m_pclMainWindow);
		SetSDLControl(&m_clControl);
	}
}


Main::~Main()
{
	if (m_pclMainWindow)
	{
		delete m_pclMainWindow;
	}
}


bool Main::IsOK()
{
#ifdef WIN32
	if (!m_clWinSock.IsOK())
	{
		return false;
	}
#endif
	if (!m_clControl.IsOK())
	{
		return false;
	}
	return true;
}


void Main::AddForm(IOMessage *pclForm)
{
//	m_forms.insert(m_forms.end(), (Form::Form *)pclForm);
}


void Main::UserEvent(SDL_UserEvent &e)
{
	switch (e.code)
	{
	case SDL_USEREVENT_ADDFORM:
		{
			Form::Form *pclForm = reinterpret_cast<Form::Form *>(e.data1);
			pclForm -> FormCreateDialog(m_pclMainWindow);
//						AddForm( pclForm );
		}
		break;
	case SDL_USEREVENT_DISCONNECT:
		m_pclMainWindow -> Disconnect();
		m_pclMainWindow -> SetDirty(true);
		break;
	case SDL_USEREVENT_UICOMMAND:
		Surface *pclSurface;
		long cmd;
		memmove(&pclSurface,&e.data1,4);
		memmove(&cmd,&e.data2,4);
		switch (cmd)
		{
		case UICOMMAND_QUIT:
			SetQuit(true);
			break;
		case UICOMMAND_XMLSAVE:
			{
				m_pclMainWindow -> SaveDialogs();
/*
				FILE *fil;
				if ((fil = fopen("mainwindow.xml","wt")) != NULL)
				{
					fprintf(fil,"<?xml version=\"1.0\"?>\n");
					m_pclMainWindow -> Dump(fil);
					fclose(fil);
				}
*/
			}
			break;
		default:
			GuiEvent::UserEvent(e);
		}
		break;

	default:
		GuiEvent::UserEvent(e);
		break;
	}
}


void Main::KeyboardEvent(SDL_KeyboardEvent &e)
{
	if (e.type == SDL_KEYDOWN)
	{
		switch (e.keysym.sym)
		{
		case SDLK_F2:
			m_pclMainWindow -> ShowText();
			break;
		case SDLK_ESCAPE:
			m_pclMainWindow -> ShowMenu();
			break;

		// mandel test
		case SDLK_PAGEUP:
			m_pclMainWindow -> IncreaseBase();
			break;
		case SDLK_PAGEDOWN:
			m_pclMainWindow -> DecreaseBase();
			break;
		case SDLK_UP:
			Globals::m_zy -= Globals::m_scale;
			m_pclMainWindow -> Redraw();
			break;
		case SDLK_DOWN:
			Globals::m_zy += Globals::m_scale;
			m_pclMainWindow -> Redraw();
			break;
		case SDLK_RIGHT:
			Globals::m_zx += Globals::m_scale;
			m_pclMainWindow -> Redraw();
			break;
		case SDLK_LEFT:
			Globals::m_zx -= Globals::m_scale;
			m_pclMainWindow -> Redraw();
			break;
		case SDLK_HOME:
			Globals::m_scale *= 1.05;
			m_pclMainWindow -> Redraw();
			break;
		case SDLK_END:
			Globals::m_scale *= 0.95;
			m_pclMainWindow -> Redraw();
			break;

		default:
			GuiEvent::KeyboardEvent(e);
			break;
		}
	}
	else
	{
		GuiEvent::KeyboardEvent(e);
	}
}


void Main::MainLoop()
{
	SDL_Event event;

	// draw surfaces in local pixel surface
	// flyttat till basklass
//	m_pclMainWindow -> DrawAll();
//	m_pclMainWindow -> CalculateAbsolute();

//	m_pclMainWindow -> ShowText();
//	pprintf("Welcome...\n");

	event.user.type = SDL_USEREVENT;
	event.user.code = SDL_USEREVENT_PAINT;
	event.user.data1 = NULL;
	event.user.data2 = NULL;
	SDL_PushEvent(&event);

	event.type = SDL_KEYDOWN;
	event.key.keysym.sym = SDLK_F2;
	SDL_PushEvent(&event);

	SetDefaultFocus( m_pclMainWindow -> GetInput() );

	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL);

	EventLoop();
}


MainWindow *Main::GetWindow()
{
	return m_pclMainWindow;
}


