/**
 **	File ......... Main.h
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _MAIN_H
#define _MAIN_H

#ifdef WIN32
#include "WinSockInit.h"
#endif


// SDL_Event.user.code
#define SDL_USEREVENT_ADDFORM    1
#define SDL_USEREVENT_DISCONNECT 2
//
#define UICOMMAND_QUIT        1
#define UICOMMAND_XMLSAVE     2
//

typedef std::vector<Form::Form *> forms_t;

using iotm::IOMessage;
using gui::SDLControl;
using gui::GuiEvent;

class WinSockInit;
class InitSDL;
class MainWindow;
class ConnectThread;

class Main : public gui::GuiEvent
{
public:
	Main(int argc,char *argv[]);
	~Main();
	bool IsOK();
	void MainLoop();
	MainWindow *GetWindow();

private:
	void AddForm(IOMessage *);
	void KeyboardEvent(SDL_KeyboardEvent &);
	void UserEvent(SDL_UserEvent &);

#ifdef WIN32
	WinSockInit m_clWinSock;
#endif
//	InitSDL m_clInitSDL;
	SDLControl m_clControl;
	MainWindow *m_pclMainWindow;
//	forms_t m_forms;
	// mandel test
	double m_angle1;
	double m_angle2;
};


#endif // _MAIN_H
