/**
 **	File ......... MainWindow.h
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _MAINWINDOW_H
#define _MAINWINDOW_H

//#include <gui/guitypedefs.h>
#include "Grid.h"
#include "DotCursor.h"

//#define USE_IMAGE

using gui::SDLControl;
using gui::Color;
using gui::TTFont;
using gui::Static;
using gui::Edit;
using gui::Surface;
using gui::Button;
using gui::Output;
using gui::surface_event_t;
using gui::coord_t;

class MenuDialog;
class OptionsDialog;
class LoginDialog;
class PlayerDialog;
class TextDialog;
class ConnectThread;
class TestMenu;
class Grid;
class Player;
class DotCursor;
class DotMenu;


typedef struct mapdotstruct
{
	int x;
	int y;
	long cx;
	long cy;
} MAPDOT;

typedef std::vector<MAPDOT *> mapdots_t;

class MainWindow : public gui::Surface
{
public:
	MainWindow(SDLControl *);
	~MainWindow();

	void Draw();
	void AddLine(const string &);
#ifdef USE_IMAGE
	void MoveImage(int,int);
#endif
	void ShowMenu();
	void ShowOptions();
	void ShowLogin(Form::Form *);
	void ShowPlayers(Form::Form *,vector<string> &);
	void ShowText();

	void OnEvent(surface_event_t *);
	void OnMouseMove(coord_t,coord_t,coord_t,coord_t);
	void OnRightClick(coord_t,coord_t);

	void Connect();
	void Disconnect();
	Surface *GetInput();
	void SetAngles(double,double);
	void IncreaseBase();
	void DecreaseBase();
	void Redraw();

static	Grid m_grid;

private:
	int Get_h(long,long);
	int Get_t_left(long,long);
	int Get_t_up(long,long);
	TTFont courier8;	// fonts
	Edit m_guiInput;
	MenuDialog *m_pclMenuDialog;
	OptionsDialog *m_pclOptionsDialog;
	LoginDialog *m_pclLoginDialog;
	PlayerDialog *m_pclPlayerDialog;
	TextDialog *m_pclTextDialog;
	ConnectThread *m_pclConnectThread;
	TestMenu *m_pclTestMenu;
	DotMenu *m_dotMenu;
#ifdef USE_IMAGE
	SDL_Surface *m_image;	// bmp
	int m_image_x;
	int m_image_y;
#endif
	double m_test_v;
	double m_test_v_vertikal;
	mapdots_t m_dots;
	MAPDOT *m_dot;
	DotCursor m_dc;
};


#endif // _MAINWINDOW_H
