/**
 **	File ......... Map.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "events/Map.h"
#include "Map.h"




Map::Map()
{
	memset(m_h, 0, MAPSIZE * MAPSIZE);
	memset(m_terrain_left, 0, MAPSIZE * MAPSIZE);
	memset(m_terrain_up, 0, MAPSIZE * MAPSIZE);
}


Map::~Map()
{
}


void Map::Populate(Event::Map *pclMap)
{
	size_t l = MAPSIZE * MAPSIZE;
	
	memmove(m_h, pclMap -> Get_h(), l);
	memmove(m_terrain_left, pclMap -> Get_t_left(), l);
	memmove(m_terrain_up, pclMap -> Get_t_up(), l);
}


unsigned char Map::Get_h(long x,long y)
{
	int index = (y % MAPSIZE) * MAPSIZE + (x % MAPSIZE);
	return m_h[index];
}


unsigned char Map::Get_t_left(long x,long y)
{
	int index = (y % MAPSIZE) * MAPSIZE + (x % MAPSIZE);
	return m_terrain_left[index];
}


unsigned char Map::Get_t_up(long x,long y)
{
	int index = (y % MAPSIZE) * MAPSIZE + (x % MAPSIZE);
	return m_terrain_up[index];
}


