/**
 **	File ......... MenuDialog.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "client.h"
#include "OptionsDialog.h"
#include "MainWindow.h"
#include "MenuDialog.h"


MenuDialog::MenuDialog(Surface *s)
:Dialog(s, 160, 140, 320, 200)
,m_b1(this, 5, 5, 300, 25)
,m_b2(this, 5, 35, 300, 25)
,m_b3(this, 5, 65, 300, 25)
,m_b4(this, 5, 95, 300, 25)
{
	Uint32 bgcolor = SDL_MapRGBA(GetScreen() -> format, 192, 192, 192, 128);
	Uint32 txtcolor = SDL_MapRGBA(GetScreen() -> format, 255, 192, 64, 255);

	SetText("MenuDialog");
//	CreateTemporaryScreen();
	
	SetTransparent(true);
//	SetBgColor(bgcolor);
//	SetFgColor(txtcolor);

	m_b1.SetText("Connect");
	m_b2.SetText("Options");
	m_b3.SetText("Exit");
	m_b3.SetUICommand(UICOMMAND_QUIT);
	m_b4.SetText("Test");
	AddChild(&m_b1);
	AddChild(&m_b2);
	AddChild(&m_b3);
	AddChild(&m_b4);
}


MenuDialog::~MenuDialog()
{
}


void MenuDialog::OnEvent(surface_event_t *pstEvent)
{
	if (pstEvent -> type == GUI_EVENT_BUTTON)
	{
		if (pstEvent -> local_id == m_b1.GetLocalID())
		{
		// connect
			MainWindow *pcl = dynamic_cast<MainWindow *>(GetParent());
			if (pcl)
			{
				SetVisible(false);
				InvalidateEv();
				pcl -> Connect();
			}
		}
		else
		if (pstEvent -> local_id == m_b2.GetLocalID())
		{
		// options
			MainWindow *pcl = dynamic_cast<MainWindow *>(GetParent());
			if (pcl)
			{
				pcl -> ShowOptions();
			}
		}
		else
/*
		if (pstEvent -> local_id == m_b3.GetLocalID())
		{
		// exit
			appl -> SetQuit( true );
		}
		else
*/
		if (pstEvent -> local_id == m_b4.GetLocalID())
		{
			pprintf("Test button pressed\n");
		}
	}
}


void MenuDialog::Connected(const string &str)
{
	m_b1.SetText(str);
}
