/**
 **	File ......... OptionsDialog.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "client.h"
#include "Globals.h"
#include "OptionsDialog.h"


OptionsDialog::OptionsDialog(Surface *s)
:Dialog(s, 200, 200, 200, 200)
,m_st1 (this, 5, 5, 150, 25)
,m_host(this, 5, 35, 150, 25)
,m_st2 (this, 5, 65, 150, 25)
,m_port(this, 5, 95, 150, 25)
,m_ok (this, 5, 125, 90, 25)
,m_cancel(this,105,125, 90, 25)
{
	Uint32 bgcolor = SDL_MapRGBA(GetScreen() -> format, 192, 192, 192, 255);
	Uint32 bgcolor2 = SDL_MapRGBA(GetScreen() -> format, 192, 192, 255, 255);
	Uint32 txtcolor = SDL_MapRGBA(GetScreen() -> format, 255, 192, 64, 255);

	SetText("OptionsDialog");
	CreateTemporaryScreen();

//	SetBgColor(bgcolor);
//	SetFgColor(txtcolor);
	SetMoveable(true);

	m_st1.SetText("Host");
//	m_host.SetBgColor(bgcolor2);
	m_st2.SetText("Port");
//	m_port.SetBgColor(bgcolor2);
	m_ok.SetText("OK");
	m_ok.SetAnchorDown(true);
//	m_ok.SetBgColor(bgcolor2);
	m_cancel.SetText("Cancel");
	m_cancel.SetAnchorDown(true);
	m_cancel.SetAnchorRight(true);
//	m_cancel.SetBgColor(bgcolor2);
	
	UpdateData(false);
	
	AddChild(&m_st1);
	AddChild(&m_host);
	AddChild(&m_st2);
	AddChild(&m_port);
	AddChild(&m_ok);
	AddChild(&m_cancel);
}


OptionsDialog::~OptionsDialog()
{
}


void OptionsDialog::OnEvent(surface_event_t *pstEvent)
{
	if (pstEvent -> type == GUI_EVENT_BUTTON)
	{
		if (pstEvent -> local_id == m_ok.GetLocalID())
		{
			UpdateData();
			OnClose();
		}
		else
		if (pstEvent -> local_id == m_cancel.GetLocalID())
		{
			OnClose();
		}
	}
}


void OptionsDialog::Draw()
{
	SDL_Rect *area = GetClientRectPtr();
	Uint32 color = GetBgColor();

	SDL_FillRect(m_screen, area, color);
}


void OptionsDialog::UpdateData(bool dlg2vars)
{
	if (dlg2vars)
	{
		Globals::m_host = m_host.GetLine();
		Globals::m_port = atoi(m_port.GetLine());
	}
	else
	{
		char slask[200];
		m_host.SetLine(Globals::m_host.c_str());
		sprintf(slask,"%d",Globals::m_port);
		m_port.SetLine(slask);
	}
}

