/**
 **	File ......... PlayerDialog.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "forms/PlayerSelect.h"
#include "MainWindow.h"
#include "PlayerDialog.h"

using Form::PlayerSelect;


PlayerDialog::PlayerDialog(Surface *s)
:FormSurface(s,220,100,200,200)
,y(5)
{
	Uint32 bgcolor = SDL_MapRGBA(GetScreen() -> format,192,192,192,SDL_ALPHA_OPAQUE);
	Uint32 fgcolor = SDL_MapRGBA(GetScreen() -> format,255,192,64,SDL_ALPHA_OPAQUE);

	SetText("PlayerDialog");
	CreateTemporaryScreen();
	SetMoveable(true);

//	SetBgColor(bgcolor);
//	SetFgColor(fgcolor);
}


PlayerDialog::~PlayerDialog()
{
	surfacevector_t::iterator it;
	for (it = m_ChildList.begin(); it != m_ChildList.end(); it++)
	{
		delete *it;
	}
}


void PlayerDialog::OnEvent(surface_event_t *pstEvent)
{
	PlayerSelect *pcf = dynamic_cast<PlayerSelect *>(GetForm());
	Button *pcb = dynamic_cast<Button *>(pstEvent -> ptr);
	
	if (pcf && pcb)
	{
		pcf -> SelectPlayer(pcb -> GetText());
	}
	OnClose();
}


void PlayerDialog::Draw()
{
	SDL_Rect *area = GetClientRectPtr();
	Uint32 color = GetBgColor();

	SDL_FillRect(m_screen, area, color);
}


void PlayerDialog::AddButton(const string &str)
{
	Button *pclButton;

	pclButton = new Button(this, 5, y, 190, 25);
	pclButton -> SetText(str);
	pclButton -> SetBgColor( 160, 160, 160 );
	pclButton -> SetMustBeDeleted(true);
	AddChild(pclButton);
	y += 30;
}


void PlayerDialog::Clear()
{
	surfacevector_t::iterator it;
	Surface *s;
	bool repeat = true;

	while (repeat)
	{
		repeat = false;
		for (it = m_ChildList.begin(); it != m_ChildList.end(); it++)
		{
			s = *it;
			if (dynamic_cast<Button *>(s))
			{
				Remove(s);
				repeat = true;
				break;
			}
		}
	}
	y = 5;
}
