/**
 **	File ......... TestMenu.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "client.h"
#include "MainWindow.h"
#include "TestMenu.h"


using gui::Surface;
using gui::SurfaceHelper;
using gui::Menu;
using gui::surface_event_t;


TestMenu::TestMenu(Surface *s,SurfaceHelper *pclHelper)
:Menu(s,pclHelper)
#ifdef WIN32
,m_font("font.ttf", 10)
#else
,m_font("../gui/fonts/font.ttf", 10)
#endif
,m_item1(this,"Connect",&m_font /*, font, pclHelper*/ )
,m_item2(this,"Options",&m_font)
,m_item3(this,"Test",&m_font)
,m_item4(this,"Exit",&m_font)
,m_title(this,"Test Menu",&m_font)
,m_item6(this,"YAM",&m_font,1)
,m_sep2(this)
,m_save(this,"Save (XML)",&m_font)
,m_sep(this)
{
	SetTTFont(&m_font);

	m_title.SetClickable(false);
	m_item4.SetUICommand(UICOMMAND_QUIT);
	m_save.SetUICommand(UICOMMAND_XMLSAVE);
	AddMenuItem(&m_title);
	AddMenuItem(&m_save);
	AddMenuItem(&m_sep);
	AddMenuItem(&m_item1);
	AddMenuItem(&m_item2);
	AddMenuItem(&m_item3);
	AddMenuItem(&m_item6);
	AddMenuItem(&m_sep2);
	AddMenuItem(&m_item4);
	CreateMenu();
	CreateTemporaryScreen();

	m_title.SetBgColor(0,0,0);
	m_title.SetFgColor(255,255,255);
	m_sep.SetFgColor(128,128,128);
	m_sep2.SetFgColor(128,128,128);

	SetMoveable(true);
}


TestMenu::~TestMenu()
{
}


void TestMenu::OnEvent(surface_event_t *pstEvent)
{
	if (pstEvent -> type == GUI_EVENT_BUTTON)
	{
		if (pstEvent -> local_id == m_item1.GetLocalID())
		{
		// connect
			MainWindow *pcl = dynamic_cast<MainWindow *>(GetParent());
			if (pcl)
			{
				SetVisible(false);
				InvalidateEv();
				pcl -> Connect();
			}
		}
		else
		if (pstEvent -> local_id == m_item2.GetLocalID())
		{
		// options
			MainWindow *pcl = dynamic_cast<MainWindow *>(GetParent());
			if (pcl)
			{
				pcl -> ShowOptions();
			}
		}
		else
		if (pstEvent -> local_id == m_item3.GetLocalID())
		{
			pprintf("Test button pressed\n");
		}
/*
		else
		if (pstEvent -> local_id == m_item4.GetLocalID())
		{
		// exit
			appl -> SetQuit( true );
		}
*/
	}
}


gui::Menu *TestMenu::GetSubMenu(int id)
{
	if (id == 1)
	{
		return new TestMenu(GetParent());
	}
	return NULL;
}


