/**
 **	File ......... mandel.cpp
 **	Published ....  2005-02-07
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdincl.h>

#include "Globals.h"
#include "mandel.h"


int mandel_color(double x,double y)
{
  double cx,cy;
  double limit;
  double ax,ay;
  double a1,b1;
  double lp;
  double a2,b2;

  cx = -0.3 + Globals::m_zx; 
  cy = -0.66 + Globals::m_zy; 
//  Globals::m_scale = 0.002;
  limit = 4;

  //        {What is the  * mathematical *  value of this point?}
  ax = cx + (x) * Globals::m_scale; 
  ay = cy + (y) * Globals::m_scale;

//        {And now for the magic formula!}
  a1 = ax; 
  b1 = ay; 
  lp = 0;
#define STOPLIM 40
  do
  {
//          {Do one iteration.}
    lp = lp + 1;
    a2 = a1 * a1 - b1 * b1 + ax;
    b2 = 2 * a1 * b1 + ay;
//          {This is indeed the square of a + b1, done component-wise.}
    a1 = a2; 
    b1 = b2;
  } while (!(lp > STOPLIM || ((a1 * a1) + (b1 * b1) > limit)));
//        {The first condition is satisfied if we have convergence.
//        The second is satisfied if we have divergence.}

//        {Define colour and draw pixel.}
  if (lp > STOPLIM)
  {
    lp = STOPLIM;
  }
//        {If the point converges, it is part of the brot and we
//        draw it with colour 0, or black.}
//        pixel(x + 160,y + 100,lp);
  return (int)lp;
}


void mandel_set()
{
  double x,y;
  double cx,cy;
  double limit;
  double ax,ay;
  double a1,b1;
  double lp;
  double a2,b2;

// {Set up initial values for drawing. Try compiling the program
//    with different values here if you like!}
    cx = 0; 

    cy = 0; 

//    Globals::m_scale = 0.02;
    limit = 4;

//    {Loop through all pixels on screen. For reasons that will become
//    clear, I am counting not from (0,0) but from (-160,-100).}
    for (x = -160; x < 160; x++)
    {
      for (y = -100; y <= 100; y++)
      {
//        {What is the  * mathematical *  value of this point?}
        ax = cx + x * Globals::m_scale; 

        ay = cy + y * Globals::m_scale;

//        {And now for the magic formula!}
        a1 = ax; 

        b1 = ay; 

        lp = 0;
        do
        {
//          {Do one iteration.}
          lp = lp + 1;
          a2 = a1 * a1 - b1 * b1 + ax;
          b2 = 2 * a1 * b1 + ay;
//          {This is indeed the square of a + bi, done component-wise.}
          a1 = a2; 

          b1 = b2;
        } while (lp > 255 || ((a1 * a1) + (b1 * b1) > limit));
//        {The first condition is satisfied if we have convergence.
//        The second is satisfied if we have divergence.}

//        {Define colour and draw pixel.}
        if (lp > 255)
        {
          lp = 0;
        }
//        {If the point converges, it is part of the brot and we
//        draw it with colour 0, or black.}
//        pixel(x + 160,y + 100,lp);
      }

    } // for (x)
}
